## tree-sitter-sdml 0.3.3~20240830

=== Makefile ===
# ----------------------------------------------------------------------------
# Config Names
# ----------------------------------------------------------------------------

ROOT := $(PWD)

BASE_NAME := $(shell basename $(ROOT))
BASE_NAME_US := $(subst -,_,$(BASE_NAME))
SHORT_NAME := $(shell echo $(BASE_NAME) | cut -d '-' -f 3)

FILE_EXT := sdm

# ----------------------------------------------------------------------------
# Config ❯ Directories
# ----------------------------------------------------------------------------

SRC_DIR := $(ROOT)/src
TST_DIR := $(ROOT)/test

BUILD_DIR := $(ROOT)/build

BINDING_DIR := $(ROOT)/bindings

NODE_SRC_DIR := $(BINDING_DIR)/node
NODE_BUILD_DIR := $(BUILD_DIR)

PYTHON_ROOT_DIR := $(BINDING_DIR)/python
PYTHON_SRC_DIR := $(PYTHON_ROOT_DIR)/$(BASE_NAME_US)
PYTHON_BUILD_DIR := $(BUILD_DIR)
PYTHON_DIST_DIR := $(ROOT)/dist

RUST_SRC_DIR := $(BINDING_DIR)/rust
RUST_TARGET_DIR := $(BUILD_DIR)/target

INSTALL_ROOT_DIR ?= /usr/local
INSTALL_LIB_DIR := $(INSTALL_ROOT_DIR)/lib
INSTALL_INCLUDE_DIR := $(INSTALL_ROOT_DIR)/include

# ----------------------------------------------------------------------------
# Config ❯ Tools
# ----------------------------------------------------------------------------

TS_CLI := tree-sitter
TS_GENERATE_ABI ?=latest
TS_GENERATE := generate --abi=$(TS_GENERATE_ABI)
TS_TEST := test

# ----------------------------------------------------------------------------
# Config ❯ Build Flags
# ----------------------------------------------------------------------------

BUILD_KIND ?= release

ifeq ($(BUILD_KIND), debug)
	NODE_BUILD_TYPE := Debug
	RUST_BUILD_MODE :=
else ifeq ($(BUILD_KIND), release)
	TS_TEST_FLAGS :=
	NODE_BUILD_TYPE := Release
	RUST_BUILD_MODE := --release
else
$(error Unknown build kind: '$(BUILD_KIND)')
endif

ifeq ($(OS),Windows_NT)
	LIB_PREFIX=
	DYLIB_EXT := dll
else
	LIB_PREFIX=lib
    UNAME_S := $(shell uname -s)

	ifeq ($(UNAME_S),Linux)
		DYLIB_EXT := so
        CCFLAGS += -D LINUX
    else ifeq ($(UNAME_S),Darwin)
		DYLIB_EXT := dylib
        CCFLAGS += -D OSX
	else
$(error Unknown/unsupported platform: '$(UNAME_S)')
    endif

	ifeq ($(BUILD_KIND), debug)
		TS_TEST_FLAGS := -dD0
	endif
endif

# ----------------------------------------------------------------------------
# Config ❯ Targets
# ----------------------------------------------------------------------------

PARSER_HDR_FILE := $(SRC_DIR)/tree_sitter/parser.h
PARSER_SRC_FILE := $(SRC_DIR)/parser.c
PARSER_LIB_FILE := $(LIB_PREFIX)$(BASE_NAME).$(DYLIB_EXT)
PARSER_LIB := $(BUILD_DIR)/$(PARSER_LIB_FILE)

BINDING_NODE_LIB := $(BASE_NAME_US)_binding.node
BINDING_NODE := $(NODE_BUILD_DIR)/$(NODE_BUILD_TYPE)/$(BINDING_NODE_LIB)

BINDING_PYTHON_SDIST := $(shell python3 $(PYTHON_ROOT_DIR)/dist_name.py source)
BINDING_PYTHON_WHEEL := $(shell python3 $(PYTHON_ROOT_DIR)/dist_name.py wheel)

BINDING_RUST_LIB := lib$(BASE_NAME_US).rlib
BINDING_RUST := $(RUST_TARGET_DIR)/$(BUILD_KIND)/$(BINDING_RUST_LIB)

BINDING_WASM_LIB := $(BASE_NAME).wasm
BINDING_WASM := $(BUILD_DIR)/$(BINDING_WASM_LIB)

ALL_BINDINGS := $(BINDING_NODE) $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL) $(BINDING_RUST) $(BINDING_WASM)

# ----------------------------------------------------------------------------
# Start Here
# ----------------------------------------------------------------------------

all: build test

build: build_grammar build_parser build_bindings

test: test_grammar test_bindings

install: install_parser install_bindings

publish: publish_bindings

clean: clean_grammar clean_parser clean_bindings

# ----------------------------------------------------------------------------
# Build ❯ Directories
# ----------------------------------------------------------------------------

$(BUILD_DIR):
	$(info -> creating common build directory)
	@(mkdir -p $@)

# ----------------------------------------------------------------------------
# Build ❯ Grammar
# ----------------------------------------------------------------------------

.PHONY: clean_grammar

build_grammar: $(SRC_DIR)/grammar.json $(SRC_DIR)/node-types.json $(PARSER_SRC_FILE) $(PARSER_HDR_FILE)

$(SRC_DIR)/grammar.json: $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

$(SRC_DIR)/node-types.json: $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

$(PARSER_HDR_FILE): $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

$(PARSER_SRC_FILE): $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

test_grammar: clean_grammar $(SRC_DIR)/grammar.json
	$(info -> running grammar tests)
	$(TS_CLI) $(TS_TEST) $(TS_TEST_FLAGS)
	$(info -> parsing grammar examples)
	$(TS_CLI) parse examples/*.sdm --quiet --time

clean_grammar:
	$(info -> removing grammar cruft)
	@(rm -f $(TST_DIR)/corpus/*.$(FILE_EXT)~ $(TST_DIR)/corpus/.*.\~undo-tree\~)
	@(rm -f $(TST_DIR)/highlight/*.$(FILE_EXT)~ $(TST_DIR)/highlight/.*.\~undo-tree\~)
	@(rm -f $(TST_DIR)/tags/*.$(FILE_EXT)~ $(TST_DIR)/tags/.*.\~undo-tree\~)

# ----------------------------------------------------------------------------
# Build ❯ Parser Library
# ----------------------------------------------------------------------------

.PHONY: clean_parser

INCLUDE_DIR := $(SRC_DIR)/tree_sitter

build_parser: $(PARSER_LIB)

$(PARSER_LIB): $(PARSER_SRC_FILE) $(PARSER_HDR_FILE) | $(BUILD_DIR)
	$(info -> building parser library into $(PARSER_LIB))
	@($(TS_CLI) build -o $(PARSER_LIB))

install_parser: $(INSTALL_LIB_DIR)/$(PARSER_LIB_FILE) $(INSTALL_INCLUDE_DIR)/parser.h

$(INSTALL_LIB_DIR)/$(PARSER_LIB_FILE): $(PARSER_LIB)
	$(info -> installing parser library into $(INSTALL_LIB_DIR))
	@(install -d $(INSTALL_LIB_DIR))
	@(install -m755 $(PARSER_LIB) $(INSTALL_LIB_DIR)/$(PARSER_LIB_FILE))

$(INSTALL_INCLUDE_DIR)/parser.h: $(INCLUDE_DIR)/parser.h
	$(info -> installing parser headers into $(INSTALL_INCLUDE_DIR))
	@(install -d $(INSTALL_INCLUDE_DIR))
	@(install $(INCLUDE_DIR)/parser.h $(INSTALL_INCLUDE_DIR)/parser.h)

clean_parser:
	$(info -> removing parser build files)
	@(rm -f $(PARSER_LIB))

# ----------------------------------------------------------------------------
# Build ❯ Parser Library ❯ Emacs
# ----------------------------------------------------------------------------

.PHONY: generate_for_emacs

EMACS_TS_DIR ?= $(HOME)/.tree-sitter/bin
EMACS_ABI := 13
EMACS_BINDING := $(EMACS_TS_DIR)/$(SHORT_NAME).$(DYLIB_EXT)

emacs: $(EMACS_BINDING) | $(BUILD_DIR)

$(EMACS_BINDING): generate_for_emacs build_parser
	$(info -> installing Emacs binding into $(EMACS_TS_DIR))
	@(cp $(PARSER_LIB) $(EMACS_BINDING))

generate_for_emacs:
	$(info -> generating Emacs binding)
	$(TS_CLI) generate --abi=$(EMACS_ABI)

# ----------------------------------------------------------------------------
# Build ❯ Bindings
# ----------------------------------------------------------------------------

build_bindings: $(ALL_BINDINGS)

test_bindings: test_rust

install_bindings: install_rust install_python

publish_bindings: publish_rust publish_node publish_python

clean_bindings: clean_rust clean_node clean_python clean_wasm

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ Rust
# ----------------------------------------------------------------------------

.PHONY: clean_rust

CARGO_FLAGS :=

$(BINDING_RUST): $(PARSER_LIB) $(RUST_SRC_DIR)/build.rs
	$(info -> building Rust binding into $(BINDING_RUST))
	@(cargo build $(RUST_BUILD_MODE) --target-dir $(RUST_TARGET_DIR))

test_rust: $(BINDING_RUST)
	$(info -> running Rust binding tests)
	@(cargo test $(RUST_BUILD_MODE) --target-dir $(RUST_TARGET_DIR))

install_rust: $(BINDING_RUST)
	$(info -> installing Rust binding locally)
	@(cargo install --path '.' --locked --target-dir $(RUST_TARGET_DIR))

publish_rust: $(BINDING_RUST)
	$(info -> publishing Rust binding to crates.io)
	@(cargo publish --allow-dirty --target-dir $(RUST_TARGET_DIR))

clean_rust:
	$(info -> removing Rust binding files)
	@(rm -rf $(RUST_TARGET_DIR))

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ Node
# ----------------------------------------------------------------------------

.PHONY: clean_node

$(BINDING_NODE): $(ROOT)/binding.gyp $(NODE_BUILD_DIR)/Makefile $(NODE_SRC_DIR)/index.js $(NODE_SRC_DIR)/index.d.ts $(NODE_SRC_DIR)/binding.cc $(ROOT)/node_modules
	$(info -> building Node binding into $(BINDING_NODE))
	@(node-gyp build)

$(NODE_BUILD_DIR)/Makefile: $(ROOT)/binding.gyp
	$(info -> configure Node binding)
	@(node-gyp configure)

publish_node: $(BINDING_NODE)
	$(info -> publishing Node binding to npmjs)
	@(npm publish)

$(ROOT)/node_modules: $(ROOT)/package.json
	$(info -> install Node dependencies from $(ROOT)/package.json)
	@(npm install)

clean_node:
	$(info -> removing Node binding files)
	@(rm -rf $(NODE_BUILD_DIR))
	$(info -> removing Node local modules)
	@(rm -rf $(ROOT)/node_modules)

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ Python
# ----------------------------------------------------------------------------

PYTHON_VENV=dev
VENV_DIR=$(ROOT)/$(PYTHON_VENV)
VENV_BIN=$(VENV_DIR)/bin
VENV_BUILD=$(VENV_BIN)/pyproject-build
VENV_PYTHON=$(VENV_BIN)/python3
VENV_PIP=$(VENV_BIN)/pip3

.PHONY: install_python clean_python $(VENV_DIR)

$(BINDING_PYTHON_SDIST): $(PYTHON_SRC_DIR)/binding.c $(PYTHON_SRC_DIR)/__init__.py $(VENV_BUILD)
	$(info -> building Python source distribution into $(BINDING_PYTHON_SDIST))
	@($(VENV_BUILD))

$(BINDING_PYTHON_WHEEL): $(BINDING_PYTHON_SDIST)

$(VENV_BUILD): $(VENV_DIR)
	$(info -> setup Python build tool)
	@($(VENV_PIP) install build)

$(VENV_DIR):
	$(info -> creating virtual environment in $(VENV_DIR))
	@(python3 -m venv $(PYTHON_VENV))

install_python:
	$(info -> installing Python binding into local venv)
	@($(VENV_PIP) install -e .)

publish_python: $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL) setup_twine
	$(info -> uploading Python binding to PyPI)
	@(twine --sign --identity $(GPG_SIGNER) --non-interactive upload $(PYTHON_DIST_DIR)/*)

clean_python:
	$(info -> removing Python binding files)
	@(rm -rf $(ROOT)/dist)
	@(rm -rf $(PYTHON_ROOT_DIR)/tree_sitter_sdml.egg-info)
	$(info -> removing Python virtual environment)
	@(rm -rf $(ROOT)/$(PYTHON_VENV))
	$(info -> removing Python top-level cruft)
	@(rm -rf $(ROOT)/.eggs $(ROOT)/.mypy_cache)

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ WASM
# ----------------------------------------------------------------------------

.PHONY: clean_wasm

$(BINDING_WASM): $(PARSER_LIB) $(SRC_DIR)/grammar.json | $(BUILD_DIR)
	$(info -> building WASM binding file into $(BINDING_WASM))
	@($(TS_CLI) build --wasm --output $(BINDING_WASM))

clean_wasm:
	$(info -> removing WASM binding file)
	@(rm -f $(BINDING_WASM))

# ----------------------------------------------------------------------------
# Setup
# ----------------------------------------------------------------------------

INSTALLER=brew
INSTALL_CMD=$(INSTALLER) install

.PHONY: node npm emscripten twine

setup: setup_node setup_npm setup_emscripten setup_twine

CMD_NODE := $(shell command -v node 2> /dev/null)
setup_node: $(CMD_NODE)
	$(info -> installing node)
	@($(INSTALL_CMD) node)

CMD_NPM := $(shell command -v npm 2> /dev/null)
setup_npm: $(CMD_NPM)
	$(info -> installing npm)
	@($(INSTALL_CMD) npm)

CMD_EMSCRIPTEN := $(shell command -v emscripten 2> /dev/null)
setup_emscripten: $(CMD_EMSCRIPTEN)
	$(info -> installing emscripten)
	@($(INSTALL_CMD) emscripten)

CMD_TWINE := $(shell command -v twine 2> /dev/null)
setup_twine: $(CMD_TWINE)
	$(info -> installing twine)
	@($(INSTALL_CMD) twine)

=== debian/changelog ===
tree-sitter-sdml (0.3.3~20240830-2) unstable; urgency=medium

  * add patch 2004
    to hint that libtree-sitter does not require source with binaries

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 14 Sep 2024 23:27:23 +0200

tree-sitter-sdml (0.3.3~20240830-1) unstable; urgency=medium

  [ upstream ]
  * new development snapshot

  [ Jonas Smedegaard ]
  * update watch file: bump version prefix
  * fix Vcs-* fields
  * add patch 2003 to accept older branches of crate tree-sitter
  * bump project versions in virtual packages and autopkgtests

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 07 Sep 2024 23:02:46 +0200

tree-sitter-sdml (0.3.2+20240709-1) experimental; urgency=medium

  * initial release;
    closes: bug#1080003

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 29 Aug 2024 15:49:20 +0200

=== debian/control ===
Source: tree-sitter-sdml
Section: devel
Priority: optional
Maintainer: Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-0.20+default-dev,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-setuptools,
Standards-Version: 4.7.0
Homepage: https://github.com/sdm-lang/tree-sitter-sdml
Vcs-Git: https://salsa.debian.org/debian/tree-sitter-sdml.git
Vcs-Browser: https://salsa.debian.org/debian/tree-sitter-sdml
Rules-Requires-Root: no
Description: sdml grammar for the tree-sitter parser
 tree-sitter-sdml is a tree-sitter grammar for SDML.
 .
 Tree-sitter is a parser generator and incremental parsing library.
 .
 The Simple Domain Modeling Language (SDML) is
 a small data-oriented language
 for constructing, documenting, and reasoning
 about a conceptual domain model.

Package: librust-tree-sitter-sdml-dev
Section: rust
Architecture: all
Multi-Arch: foreign
Depends:
 librust-tree-sitter-0.20+default-dev,
 ${misc:Depends},
Provides:
 librust-tree-sitter-sdml-0.3+default-dev (= ${binary:Version}),
 librust-tree-sitter-sdml-0.3-dev (= ${binary:Version}),
 librust-tree-sitter-sdml-0.3.3-dev (= ${binary:Version}),
Description: ${source:Synopsis} - Rust source code
 ${source:Extended-Description}
 .
 This package contains the source for the Rust tree-sitter-sdml crate,
 packaged for use with cargo.

Package: python3-tree-sitter-sdml
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - Python bindings
 ${source:Extended-Description}
 .
 This package contains the Python 3.x bindings for tree-sitter-sdml.

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.3.3
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml-0.3:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.3-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.3.3
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml-0.3:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.3-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.3.3
 --all-targets
Features: test-name=rust-tree-sitter-sdml-0.3:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.3+default-dev,
Restrictions: allow-stderr

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
mode=git,pgpmode=none,pretty=0.3.3~%cd,\
dversionmangle=auto \
https://github.com/sdm-lang/tree-sitter-sdml \
HEAD

## tree-sitter-sdml 0.3.4

=== Makefile ===
--- 
+++ 
@@ -105,7 +105,7 @@
 BINDING_WASM_LIB := $(BASE_NAME).wasm
 BINDING_WASM := $(BUILD_DIR)/$(BINDING_WASM_LIB)
 
-ALL_BINDINGS := $(BINDING_NODE) $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL) $(BINDING_RUST) $(BINDING_WASM)
+ALL_BINDINGS := $(BINDING_NODE) $(BINDING_RUST) $(BINDING_WASM) # $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL)
 
 # ----------------------------------------------------------------------------
 # Start Here
@@ -221,11 +221,11 @@
 
 test_bindings: test_rust
 
-install_bindings: install_rust install_python
-
-publish_bindings: publish_rust publish_node publish_python
-
-clean_bindings: clean_rust clean_node clean_python clean_wasm
+install_bindings: install_rust # install_python
+
+publish_bindings: publish_rust publish_node # publish_python
+
+clean_bindings: clean_rust clean_node clean_wasm # clean_python
 
 # ----------------------------------------------------------------------------
 # Build ❯ Bindings ❯ Rust

=== debian/changelog ===
tree-sitter-sdml (0.3.4-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file: bump version prefix
  * bump project versions in virtual packages and autopkgtests
  * update patch 2003

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 27 Oct 2024 03:17:15 +0100

=== debian/control ===
--- 
+++ 
@@ -36,7 +36,7 @@
 Provides:
  librust-tree-sitter-sdml-0.3+default-dev (= ${binary:Version}),
  librust-tree-sitter-sdml-0.3-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.3.3-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.3.4-dev (= ${binary:Version}),
 Description: ${source:Synopsis} - Rust source code
  ${source:Extended-Description}
  .

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.3.4
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml-0.3:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.3-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.3.4
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml-0.3:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.3-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.3.4
 --all-targets
Features: test-name=rust-tree-sitter-sdml-0.3:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.3+default-dev,
Restrictions: allow-stderr

## tree-sitter-sdml 0.4.0

=== Makefile ===
--- 
+++ 
@@ -221,11 +221,11 @@
 
 test_bindings: test_rust
 
-install_bindings: install_rust # install_python
-
-publish_bindings: publish_rust publish_node # publish_python
-
-clean_bindings: clean_rust clean_node clean_wasm # clean_python
+install_bindings: install_rust install_python
+
+publish_bindings: publish_rust publish_node publish_python
+
+clean_bindings: clean_rust clean_node clean_wasm clean_python
 
 # ----------------------------------------------------------------------------
 # Build ❯ Bindings ❯ Rust

=== debian/changelog ===
tree-sitter-sdml (0.4.0-1build1) plucky; urgency=medium

  * SRU: #2083480: No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Nov 2024 09:58:28 +0100

tree-sitter-sdml (0.4.0-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * bump project versions in virtual packages and autopkgtests
  * install examples

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 05 Nov 2024 14:19:03 +0100

=== debian/control ===
--- 
+++ 
@@ -34,9 +34,9 @@
  librust-tree-sitter-0.20+default-dev,
  ${misc:Depends},
 Provides:
- librust-tree-sitter-sdml-0.3+default-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.3-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.3.4-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4+default-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4.0-dev (= ${binary:Version}),
 Description: ${source:Synopsis} - Rust source code
  ${source:Extended-Description}
  .

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.0
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.0
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.0
 --all-targets
Features: test-name=rust-tree-sitter-sdml:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4+default-dev,
Restrictions: allow-stderr

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
mode=git,pgpmode=none,pretty=0.3.4+%cd,\
dversionmangle=auto \
https://github.com/sdm-lang/tree-sitter-sdml \
HEAD

## tree-sitter-sdml 0.4.1+20241115

=== Makefile ===
--- 
+++ 
@@ -199,7 +199,7 @@
 
 .PHONY: generate_for_emacs
 
-EMACS_TS_DIR ?= $(HOME)/.tree-sitter/bin
+EMACS_TS_DIR ?= $(HOME)/.emacs.d/tree-sitter/
 EMACS_ABI := 13
 EMACS_BINDING := $(EMACS_TS_DIR)/$(SHORT_NAME).$(DYLIB_EXT)

=== debian/changelog ===
tree-sitter-sdml (0.4.1+20241115-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file: bump version prefix
  * bump project versions in virtual packages and autopkgtests
  * update and tighten patch 2003
  * update copyright info: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 17 Jan 2025 15:22:07 +0100

tree-sitter-sdml (0.4.0-2) experimental; urgency=medium

  * update patch 2003 to cover newer branch;
    bump (build-)dependency for crate tree-sitter

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 14 Jan 2025 20:57:37 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  dh-python,
  dh-rust,
  librust-cc-1+default-dev,
- librust-tree-sitter-0.20+default-dev,
+ librust-tree-sitter-0.22+default-dev,
  pybuild-plugin-pyproject,
  python3-all-dev,
  python3-setuptools,
@@ -31,12 +31,12 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
- librust-tree-sitter-0.20+default-dev,
+ librust-tree-sitter-0.22+default-dev,
  ${misc:Depends},
 Provides:
  librust-tree-sitter-sdml-0.4+default-dev (= ${binary:Version}),
  librust-tree-sitter-sdml-0.4-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.4.0-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4.1-dev (= ${binary:Version}),
 Description: ${source:Synopsis} - Rust source code
  ${source:Extended-Description}
  .

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.1
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.1
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.1
 --all-targets
Features: test-name=rust-tree-sitter-sdml:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4+default-dev,
Restrictions: allow-stderr

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
mode=git,pgpmode=none,pretty=0.4.1+%cd,\
dversionmangle=auto \
https://github.com/sdm-lang/tree-sitter-sdml \
HEAD

## tree-sitter-sdml 0.4.5

=== Makefile ===
--- 
+++ 
@@ -74,7 +74,7 @@
         CCFLAGS += -D LINUX
     else ifeq ($(UNAME_S),Darwin)
 		DYLIB_EXT := dylib
-        CCFLAGS += -D OSX
+        CCFLAGS += -D OSX -I /opt/homebrew/include
 	else
 $(error Unknown/unsupported platform: '$(UNAME_S)')
     endif
@@ -199,14 +199,14 @@
 
 .PHONY: generate_for_emacs
 
-EMACS_TS_DIR ?= $(HOME)/.emacs.d/tree-sitter/
+EMACS_TS_DIR ?= $(HOME)/.tree-sitter/bin/
 EMACS_ABI := 13
 EMACS_BINDING := $(EMACS_TS_DIR)/$(SHORT_NAME).$(DYLIB_EXT)
 
 emacs: $(EMACS_BINDING) | $(BUILD_DIR)
 
 $(EMACS_BINDING): generate_for_emacs build_parser
-	$(info -> installing Emacs binding into $(EMACS_TS_DIR))
+	$(info -> installing Emacs binding into $(EMACS_TS_DIR)$(SHORT_NAME).$(DYLIB_EXT))
 	@(cp $(PARSER_LIB) $(EMACS_BINDING))
 
 generate_for_emacs:
@@ -316,7 +316,7 @@
 
 publish_python: $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL) setup_twine
 	$(info -> uploading Python binding to PyPI)
-	@(twine --sign --identity $(GPG_SIGNER) --non-interactive upload $(PYTHON_DIST_DIR)/*)
+	@(twine upload --sign --identity $(GPG_SIGNER) --non-interactive $(PYTHON_DIST_DIR)/*)
 
 clean_python:
 	$(info -> removing Python binding files)

=== debian/changelog ===
tree-sitter-sdml (0.4.5-2) unstable; urgency=medium

  * rewrite patch 2003
    to accept newer minor version of crate tree-sitter;
    bump (build-)dependency for crate tree-sitter

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 14 Oct 2025 13:35:30 +0200

tree-sitter-sdml (0.4.5-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * add metadata about upstream project
  * update git-buildpackage config: improve usage comment
  * update watch file:
    + mangle filename and upstream version
    + track release tags (not git commits)
  * declare compliance with Debian Policy 4.7.2
  * bump project versions in virtual packages and autopkgtests

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 08 Mar 2025 22:38:12 +0100

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
  dh-python,
  dh-rust,
  librust-cc-1+default-dev,
- librust-tree-sitter-0.22+default-dev,
+ librust-tree-sitter-0.25+default-dev,
  pybuild-plugin-pyproject,
  python3-all-dev,
  python3-setuptools,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/sdm-lang/tree-sitter-sdml
 Vcs-Git: https://salsa.debian.org/debian/tree-sitter-sdml.git
 Vcs-Browser: https://salsa.debian.org/debian/tree-sitter-sdml
@@ -31,12 +31,12 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
- librust-tree-sitter-0.22+default-dev,
+ librust-tree-sitter-0.25+default-dev,
  ${misc:Depends},
 Provides:
  librust-tree-sitter-sdml-0.4+default-dev (= ${binary:Version}),
  librust-tree-sitter-sdml-0.4-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.4.1-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4.5-dev (= ${binary:Version}),
 Description: ${source:Synopsis} - Rust source code
  ${source:Extended-Description}
  .

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.5
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.5
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.5
 --all-targets
Features: test-name=rust-tree-sitter-sdml:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4+default-dev,
Restrictions: allow-stderr

## tree-sitter-sdml 0.4.10+20250527

=== Makefile ===
--- 
+++ 
@@ -314,7 +314,7 @@
 	$(info -> installing Python binding into local venv)
 	@($(VENV_PIP) install -e .)
 
-publish_python: $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL) setup_twine
+publish_python: $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL)
 	$(info -> uploading Python binding to PyPI)
 	@(twine upload --sign --identity $(GPG_SIGNER) --non-interactive $(PYTHON_DIST_DIR)/*)

=== debian/changelog ===
tree-sitter-sdml (0.4.10+20250527-2) experimental; urgency=medium

  * build-depend on libstd-rust-dev
  * drop watch file: use upstream metadata instead

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 28 Aug 2025 23:29:46 +0200

tree-sitter-sdml (0.4.10+20250527-1) experimental; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update and unfuzz patches
  * bump project versions in virtual packages and autopkgtests
  * bump (build-)dependencies for crate tree-sitter

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 29 Jun 2025 11:46:57 +0200

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  dh-rust,
  librust-cc-1+default-dev,
  librust-tree-sitter-0.25+default-dev,
+ libstd-rust-dev,
  pybuild-plugin-pyproject,
  python3-all-dev,
  python3-setuptools,
@@ -36,7 +37,7 @@
 Provides:
  librust-tree-sitter-sdml-0.4+default-dev (= ${binary:Version}),
  librust-tree-sitter-sdml-0.4-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.4.5-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4.10-dev (= ${binary:Version}),
 Description: ${source:Synopsis} - Rust source code
  ${source:Extended-Description}
  .

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.10
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.10
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.10
 --all-targets
Features: test-name=rust-tree-sitter-sdml:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4+default-dev,
Restrictions: allow-stderr

## tree-sitter-sdml 0.4.13

=== Makefile ===
--- 
+++ 
@@ -43,7 +43,9 @@
 TS_CLI := tree-sitter
 TS_GENERATE_ABI ?=latest
 TS_GENERATE := generate --abi=$(TS_GENERATE_ABI)
+TS_PARSE := parse
 TS_TEST := test
+TS_TEST_FLAGS :=
 
 # ----------------------------------------------------------------------------
 # Config ❯ Build Flags
@@ -55,7 +57,6 @@
 	NODE_BUILD_TYPE := Debug
 	RUST_BUILD_MODE :=
 else ifeq ($(BUILD_KIND), release)
-	TS_TEST_FLAGS :=
 	NODE_BUILD_TYPE := Release
 	RUST_BUILD_MODE := --release
 else
@@ -105,7 +106,8 @@
 BINDING_WASM_LIB := $(BASE_NAME).wasm
 BINDING_WASM := $(BUILD_DIR)/$(BINDING_WASM_LIB)
 
-ALL_BINDINGS := $(BINDING_NODE) $(BINDING_RUST) $(BINDING_WASM) # $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL)
+ALL_BINDINGS := $(BINDING_NODE) $(BINDING_RUST) $(BINDING_WASM)
+#  FIXME:       $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL)
 
 # ----------------------------------------------------------------------------
 # Start Here
@@ -155,7 +157,7 @@
 	$(info -> running grammar tests)
 	$(TS_CLI) $(TS_TEST) $(TS_TEST_FLAGS)
 	$(info -> parsing grammar examples)
-	$(TS_CLI) parse examples/*.sdm --quiet --time
+	$(TS_CLI) $(TS_PARSE) examples/*.sdm --quiet --time
 
 clean_grammar:
 	$(info -> removing grammar cruft)
@@ -199,14 +201,14 @@
 
 .PHONY: generate_for_emacs
 
-EMACS_TS_DIR ?= $(HOME)/.tree-sitter/bin/
-EMACS_ABI := 13
-EMACS_BINDING := $(EMACS_TS_DIR)/$(SHORT_NAME).$(DYLIB_EXT)
+EMACS_TS_DIR ?= $(HOME)/.emacs.d/tree-sitter/
+EMACS_ABI := 14
+EMACS_BINDING := $(EMACS_TS_DIR)/$(PARSER_LIB_FILE)
 
 emacs: $(EMACS_BINDING) | $(BUILD_DIR)
 
 $(EMACS_BINDING): generate_for_emacs build_parser
-	$(info -> installing Emacs binding into $(EMACS_TS_DIR)$(SHORT_NAME).$(DYLIB_EXT))
+	$(info -> installing Emacs binding into $(EMACS_BINDING))
 	@(cp $(PARSER_LIB) $(EMACS_BINDING))
 
 generate_for_emacs:

=== debian/changelog ===
tree-sitter-sdml (0.4.13-1) experimental; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * bump project versions in virtual packages and autopkgtests
  * unfuzz patch

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 03 Oct 2025 11:02:03 +0200

=== debian/control ===
--- 
+++ 
@@ -37,7 +37,7 @@
 Provides:
  librust-tree-sitter-sdml-0.4+default-dev (= ${binary:Version}),
  librust-tree-sitter-sdml-0.4-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.4.10-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4.13-dev (= ${binary:Version}),
 Description: ${source:Synopsis} - Rust source code
  ${source:Extended-Description}
  .

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.13
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.13
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.13
 --all-targets
Features: test-name=rust-tree-sitter-sdml:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-sdml-0.4+default-dev,
Restrictions: allow-stderr

## tree-sitter-sdml 0.4.14

=== Makefile ===
# ----------------------------------------------------------------------------
# Config Names
# ----------------------------------------------------------------------------

ROOT := $(PWD)

BASE_NAME := $(shell basename $(ROOT))
BASE_NAME_US := $(subst -,_,$(BASE_NAME))
SHORT_NAME := $(shell echo $(BASE_NAME) | cut -d '-' -f 3)

UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S),Darwin)
	SEDCMD := gsed
else
	SEDCMD := sed
endif

VERSION := $(shell $(SEDCMD) -En 's/^version[[:space:]]*=[[:space:]]*"([^"]+)"/\1/p' Cargo.toml)

FILE_EXT := sdm

# ----------------------------------------------------------------------------
# Config ❯ Directories
# ----------------------------------------------------------------------------

SRC_DIR := $(ROOT)/src
TST_DIR := $(ROOT)/test

BINDING_DIR := $(ROOT)/bindings

BUILD_DIR := $(ROOT)/build

TARGET_DIR := $(ROOT)/target

NODE_SRC_DIR := $(BINDING_DIR)/node
NODE_BUILD_DIR := $(BUILD_DIR)

PYTHON_ROOT_DIR := $(BINDING_DIR)/python
PYTHON_SRC_DIR := $(PYTHON_ROOT_DIR)/$(BASE_NAME_US)
PYTHON_BUILD_DIR := $(ROOT)/build
PYTHON_TARGET_DIR := $(TARGET_DIR)/python

RUST_SRC_DIR := $(BINDING_DIR)/rust
RUST_TARGET_DIR := $(TARGET_DIR)

SWIFT_PKG_NAME := $(shell echo $(BASE_NAME_US) | $(SEDCMD) -E 's/(^|_)([a-z])/\U\2/g; s/_//g')
SWIFT_SRC_DIR := $(BINDING_DIR)/swift/$(SWIFT_PKG_NAME)
SWIFT_BUILD_DIR := $(ROOT)/.build
SWIFT_TARGET_DIR := $(TARGET_DIR)/swift

INSTALL_ROOT_DIR ?= /usr/local
INSTALL_LIB_DIR := $(INSTALL_ROOT_DIR)/lib
INSTALL_INCLUDE_DIR := $(INSTALL_ROOT_DIR)/include

WASM_TARGET_DIR := $(TARGET_DIR)/wasm

# ----------------------------------------------------------------------------
# Config ❯ Tools
# ----------------------------------------------------------------------------

MISE := mise exec

TS_CLI := $(MISE) tree-sitter -- tree-sitter
TS_WASM_CLI := $(MISE) emsdk tree-sitter -- tree-sitter
TS_BUILD := build
TS_GENERATE_ABI ?=latest
TS_GENERATE := generate --log --abi=$(TS_GENERATE_ABI)
TS_PARSE := parse
TS_TEST := test
TS_TEST_FLAGS :=

# ----------------------------------------------------------------------------
# Config ❯ Build Flags
# ----------------------------------------------------------------------------

BUILD_KIND ?= release

ifeq ($(BUILD_KIND), debug)
	NODE_BUILD_TYPE := Debug
	RUST_BUILD_MODE :=
else ifeq ($(BUILD_KIND), release)
	NODE_BUILD_TYPE := Release
	RUST_BUILD_MODE := --release
else
	$(error Unknown build kind: '$(BUILD_KIND)')
endif

ifeq ($(OS),Windows_NT)
	LIB_PREFIX=
	DYLIB_EXT := dll
else
	LIB_PREFIX=lib

	ifeq ($(UNAME_S),Linux)
		DYLIB_EXT := so
        CCFLAGS += -D LINUX
    else ifeq ($(UNAME_S),Darwin)
		DYLIB_EXT := dylib
        CCFLAGS += -D OSX -I /opt/homebrew/include
	else
		$(error Unknown/unsupported platform: '$(UNAME_S)')
    endif

	ifeq ($(BUILD_KIND), debug)
		TS_TEST_FLAGS := -dD0
	endif
endif

# ----------------------------------------------------------------------------
# Config ❯ Targets
# ----------------------------------------------------------------------------

PARSER_HDR_FILE := $(SRC_DIR)/tree_sitter/parser.h
PARSER_SRC_FILE := $(SRC_DIR)/parser.c
PARSER_LIB_FILE := $(LIB_PREFIX)$(BASE_NAME).$(DYLIB_EXT)
PARSER_LIB := $(BUILD_DIR)/$(PARSER_LIB_FILE)

BINDING_NODE_LIB := $(BASE_NAME_US)_binding.node
BINDING_NODE := $(NODE_BUILD_DIR)/$(NODE_BUILD_TYPE)/$(BINDING_NODE_LIB)

BINDING_PYTHON_SDIST := $(shell python3 $(PYTHON_ROOT_DIR)/dist_name.py source $(PYTHON_TARGET_DIR))
BINDING_PYTHON_WHEEL := $(shell python3 $(PYTHON_ROOT_DIR)/dist_name.py wheel $(PYTHON_TARGET_DIR))

BINDING_RUST_LIB := lib$(BASE_NAME_US).rlib
BINDING_RUST := $(RUST_TARGET_DIR)/$(BUILD_KIND)/$(BINDING_RUST_LIB)

BINDING_WASM_LIB := $(BASE_NAME).wasm
BINDING_WASM := $(WASM_TARGET_DIR)/$(BINDING_WASM_LIB)

BINDING_SWIFT := $(SWIFT_PKG_NAME).swift
BINDING_SWIFT_SRC := $(SWIFT_TARGET_DIR)/$(SWIFT_PKG_NAME)-$(VERSION)-src.zip

ALL_BINDINGS := $(BINDING_RUST) $(BINDING_NODE) $(BINDING_WASM) $(BINDING_SWIFT_SRC) $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL)

# ----------------------------------------------------------------------------
# Start Here
# ----------------------------------------------------------------------------

all: build test

build: build_grammar build_parser build_bindings

test: test_grammar test_bindings

install: install_parser install_bindings

publish: publish_bindings

clean: clean_grammar clean_parser clean_bindings

# ----------------------------------------------------------------------------
# Build ❯ Directories
# ----------------------------------------------------------------------------

$(BUILD_DIR):
	$(info -> creating common build directory)
	@(mkdir -p $@)

$(TARGET_DIR):
	$(info -> creating common target directory)
	@(mkdir -p $@)

$(PYTHON_TARGET_DIR):
	$(info -> creating Python target directory)
	@(mkdir -p $@)

$(SWIFT_TARGET_DIR):
	$(info -> creating Swift target directory)
	@(mkdir -p $@)

$(WASM_TARGET_DIR):
	$(info -> creating WASM target directory)
	@(mkdir -p $@)

# ----------------------------------------------------------------------------
# Build ❯ Grammar
# ----------------------------------------------------------------------------

.PHONY: clean_grammar

build_grammar: $(SRC_DIR)/grammar.json $(SRC_DIR)/node-types.json $(PARSER_SRC_FILE) $(PARSER_HDR_FILE)

$(SRC_DIR)/grammar.json: $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

$(SRC_DIR)/node-types.json: $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

$(PARSER_HDR_FILE): $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

$(PARSER_SRC_FILE): $(ROOT)/grammar.js
	$(TS_CLI) $(TS_GENERATE)

test_grammar: clean_grammar $(SRC_DIR)/grammar.json
	$(info -> running grammar tests)
	$(TS_CLI) $(TS_TEST) $(TS_TEST_FLAGS)
	$(info -> parsing grammar examples)
	$(TS_CLI) $(TS_PARSE) examples/*.sdm --quiet --time

clean_grammar:
	$(info -> removing grammar cruft)
	@(rm -f $(TST_DIR)/corpus/*.$(FILE_EXT)~ $(TST_DIR)/corpus/.*.\~undo-tree\~)
	@(rm -f $(TST_DIR)/highlight/*.$(FILE_EXT)~ $(TST_DIR)/highlight/.*.\~undo-tree\~)
	@(rm -f $(TST_DIR)/tags/*.$(FILE_EXT)~ $(TST_DIR)/tags/.*.\~undo-tree\~)

# ----------------------------------------------------------------------------
# Build ❯ Parser Library
# ----------------------------------------------------------------------------

.PHONY: clean_parser

INCLUDE_DIR := $(SRC_DIR)/tree_sitter

build_parser: $(PARSER_LIB)

$(PARSER_LIB): $(PARSER_SRC_FILE) $(PARSER_HDR_FILE) | $(BUILD_DIR)
	$(info -> building parser library v$(VERSION) into $(PARSER_LIB))
	@($(TS_CLI) $(TS_BUILD) -o $(PARSER_LIB))

install_parser: $(INSTALL_LIB_DIR)/$(PARSER_LIB_FILE) $(INSTALL_INCLUDE_DIR)/parser.h

$(INSTALL_LIB_DIR)/$(PARSER_LIB_FILE): $(PARSER_LIB)
	$(info -> installing parser library v$(VERSION) into $(INSTALL_LIB_DIR))
	@(install -d $(INSTALL_LIB_DIR))
	@(install -m755 $(PARSER_LIB) $(INSTALL_LIB_DIR)/$(PARSER_LIB_FILE))

$(INSTALL_INCLUDE_DIR)/parser.h: $(INCLUDE_DIR)/parser.h
	$(info -> installing parser headers v$(VERSION) into $(INSTALL_INCLUDE_DIR))
	@(install -d $(INSTALL_INCLUDE_DIR))
	@(install $(INCLUDE_DIR)/parser.h $(INSTALL_INCLUDE_DIR)/parser.h)

clean_parser:
	$(info -> removing parser build files)
	@(rm -f $(PARSER_LIB))

# ----------------------------------------------------------------------------
# Build ❯ Parser Library ❯ Emacs
# ----------------------------------------------------------------------------

.PHONY: generate_for_emacs

EMACS_TS_DIR ?= $(HOME)/.emacs.d/tree-sitter/
EMACS_ABI := 14
EMACS_BINDING := $(EMACS_TS_DIR)/$(PARSER_LIB_FILE)

emacs: $(EMACS_BINDING) | $(BUILD_DIR)

$(EMACS_BINDING): generate_for_emacs build_parser
	$(info -> installing Emacs binding v$(VERSION) into $(EMACS_BINDING))
	@(cp $(PARSER_LIB) $(EMACS_BINDING))

generate_for_emacs:
	$(info -> generating Emacs binding)
	$(TS_CLI) generate --abi=$(EMACS_ABI)

# ----------------------------------------------------------------------------
# Build ❯ Bindings
# ----------------------------------------------------------------------------

build_bindings: $(ALL_BINDINGS)

test_bindings: test_rust

install_bindings: install_rust

publish_bindings: publish_rust publish_node publish_python

clean_bindings: clean_rust clean_node clean_wasm clean_python clean_swift

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ Rust
# ----------------------------------------------------------------------------

.PHONY: clean_rust

CARGO := $(MISE) rust -- cargo
CARGO_FLAGS :=

$(BINDING_RUST): $(PARSER_LIB) $(RUST_SRC_DIR)/build.rs
	$(info -> building Rust binding v$(VERSION) into $(BINDING_RUST))
	@($(CARGO) build $(RUST_BUILD_MODE) --target-dir $(RUST_TARGET_DIR))

test_rust: $(BINDING_RUST)
	$(info -> testing Rust binding v$(VERSION) tests)
	@($(CARGO) test $(RUST_BUILD_MODE) --target-dir $(RUST_TARGET_DIR))

install_rust: $(BINDING_RUST)
	$(info -> installing Rust binding v$(VERSION) locally)
	@($(CARGO) install --path '.' --locked --target-dir $(RUST_TARGET_DIR))

publish_rust: $(BINDING_RUST)
	$(info -> publishing Rust binding v$(VERSION) to crates.io)
	@($(CARGO) publish --allow-dirty --target-dir $(RUST_TARGET_DIR))

clean_rust:
	$(info -> removing Rust binding files)
	@(rm -rf $(RUST_TARGET_DIR))

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ Swift
# ----------------------------------------------------------------------------

.PHONY: clean_swift

SWIFT := $(MISE) swift -- swift

$(BINDING_SWIFT_SRC): Package.swift $(SWIFT_SRC_DIR)/$(SHORT_NAME).h | $(SWIFT_TARGET_DIR)
	$(info -> building Swift source archive v$(VERSION))
	@($(SWIFT) package archive-source --output $(BINDING_SWIFT_SRC))

test_swift: $(BINDING_RUST)
	$(info -> testing Swift binding v$(VERSION) tests)
	@($(SWIFT) test)

clean_swift:
	$(info -> removing Swift build directory)
	@(rm -rf $(SWIFT_BUILD_DIR))
	$(info -> removing Swift binding files)
	@(rm -rf $(SWIFT_TARGET_DIR))

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ Node
# ----------------------------------------------------------------------------

.PHONY: clean_node

NPM := $(MISE) node -- npm
NODE_GYP := $(MISE) node npm:node-gyp npm:node-addon-api -- node-gyp

$(BINDING_NODE): $(ROOT)/binding.gyp $(NODE_BUILD_DIR)/Makefile $(NODE_SRC_DIR)/index.js $(NODE_SRC_DIR)/index.d.ts $(NODE_SRC_DIR)/binding.cc $(ROOT)/node_modules
	$(info -> building Node binding v$(VERSION) into $(BINDING_NODE))
	@($(NODE_GYP) build)

$(NODE_BUILD_DIR)/Makefile: $(ROOT)/binding.gyp
	$(info -> configure Node binding)
	@($(NODE_GYP) configure)

publish_node: $(BINDING_NODE)
	$(info -> publishing Node binding v$(VERSION) to npmjs)
	@($(NPM) publish)

$(ROOT)/node_modules: $(ROOT)/package.json
	$(info -> install Node dependencies from $(ROOT)/package.json)
	@($(NPM) install)

clean_node:
	$(info -> removing Node binding files)
	@(rm -rf $(NODE_BUILD_DIR))
	$(info -> removing Node prebuild files)
	@(rm -rf $(ROOT)/prebuilds)
	$(info -> removing Node local modules)
	@(rm -rf $(ROOT)/node_modules)

# ----------------------------------------------------------------------------
# Build ❯ Bindings ❯ Python
# ----------------------------------------------------------------------------

PIP := $(MISE) python -- pip3
PYPROJECT_BUILD := $(MISE) python -- pyproject-build
PYTHON := $(MISE) python -- python3
TWINE := $(MISE) python -- twine

.PHONY: install_python clean_python

$(BINDING_PYTHON_SDIST): $(PYTHON_SRC_DIR)/binding.c $(PYTHON_SRC_DIR)/__init__.py | $(PYTHON_TARGET_DIR)
	$(info -> building Python source distribution into $(BINDING_PYTHON_SDIST))
	@($(PYTHON) setup.py sdist -d $(PYTHON_TARGET_DIR))

$(BINDING_PYTHON_WHEEL): $(BINDING_PYTHON_SDIST) | $(PYTHON_TARGET_DIR)
	@($(PIP) wheel -w $(PYTHON_TARGET_DIR) -e . )

publish_python: $(BINDING_PYTHON_SDIST) $(BINDING_PYTHON_WHEEL)
	$(info -> uploading Python binding v$(VERSION) to PyPI)
	@($(TWINE) upload --sign --identity $(GPG_SIGNER) --non-interactive $(PYTHON_TARGET_DIR)/*)

clean_python:

=== debian/changelog ===
tree-sitter-sdml (0.4.14-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * unfuzz patches
  * bump project versions in virtual packages and autopkgtests
  * (build-)depend on package for crate tree-sitter-language;
    autopkgtest-depend (and build-depend, but not depend)
    on package for crate tree-sitter

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 14 Oct 2025 13:09:03 +0200

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  dh-rust,
  librust-cc-1+default-dev,
  librust-tree-sitter-0.25+default-dev,
+ librust-tree-sitter-language-0.1+default-dev,
  libstd-rust-dev,
  pybuild-plugin-pyproject,
  python3-all-dev,
@@ -32,12 +33,12 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
- librust-tree-sitter-0.25+default-dev,
+ librust-tree-sitter-language-0.1+default-dev,
  ${misc:Depends},
 Provides:
  librust-tree-sitter-sdml-0.4+default-dev (= ${binary:Version}),
  librust-tree-sitter-sdml-0.4-dev (= ${binary:Version}),
- librust-tree-sitter-sdml-0.4.13-dev (= ${binary:Version}),
+ librust-tree-sitter-sdml-0.4.14-dev (= ${binary:Version}),
 Description: ${source:Synopsis} - Rust source code
  ${source:Extended-Description}
  .

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic

# trust upstream optimization level unless explicitly disabled
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
export DEB_CFLAGS_MAINT_STRIP=-O2
export DEB_CXXFLAGS_MAINT_STRIP=-O2
endif

%:
	dh $@ --buildsystem=none

override_dh_auto_configure:
	dh_auto_configure --buildsystem=pybuild
	dh_auto_configure --buildsystem=rust

override_dh_auto_build:
	dh_auto_build --buildsystem=pybuild
	dh_auto_build --buildsystem=rust

override_dh_auto_test:
	dh_auto_test --buildsystem=pybuild
	dh_auto_test --buildsystem=rust

override_dh_auto_install:
	dh_auto_install --buildsystem=pybuild
	dh_auto_install --buildsystem=rust

override_dh_auto_clean:
	dh_auto_clean --buildsystem=pybuild
	dh_auto_clean --buildsystem=rust

execute_before_dh_installinit:
	dh_python3

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.14
 --all-targets --all-features
Features: test-name=rust-tree-sitter-sdml:@
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-0.25+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.14
 --all-targets --no-default-features
Features: test-name=rust-tree-sitter-sdml:
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-0.25+default-dev,
 librust-tree-sitter-sdml-0.4-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-sdml 0.4.14
 --all-targets
Features: test-name=rust-tree-sitter-sdml:default
Depends:
 dh-rust,
 librust-cc-1+default-dev,
 librust-tree-sitter-0.25+default-dev,
 librust-tree-sitter-sdml-0.4+default-dev,
Restrictions: allow-stderr
